using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

namespace GGC_UnboundComboBox
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private Hashtable unboundValues = new Hashtable();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(32, 32);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(504, 224);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableDescriptor.Name = "Default";
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(568, 286);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 100;

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			Random r = new Random();
			string[] s = new string[]{"apple", "pear", "plum"};
			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					if(j == 2)
						dr[j] = string.Format("{0}{1}", s[r.Next(3)], r.Next(100));
				else
						dr[j] = string.Format("row{0} col{1}", i, j);
				dt.Rows.Add(dr);
			}

			this.gridGroupingControl1.DataSource = dt;


			// Setup running totals by displaying the value of a custom counter in an unbound field
			FieldDescriptor unboundField = new FieldDescriptor("unbound", "", false, "");
			unboundField.ReadOnly = false;
			this.gridGroupingControl1.TableDescriptor.UnboundFields.Add(unboundField);
			GridTableCellStyleInfo style = this.gridGroupingControl1.TableDescriptor.Columns["unbound"].Appearance.AnyRecordFieldCell;
			style.CellType = "ComboBox";

			//create its datasource
			DataTable dt1 = new DataTable("unboundCombo");
			dt1.Columns.Add(new DataColumn("value"));
			DataRow r1 = dt1.NewRow();
			r1[0] = "apple";
			dt1.Rows.Add(r1);
			r1 = dt1.NewRow();
			r1[0] = "pear";
			dt1.Rows.Add(r1);
			r1 = dt1.NewRow();
			r1[0] = "plum";
			dt1.Rows.Add(r1);
			
			style.DataSource = dt1;
			style.DisplayMember = "value";
			style.ValueMember = "value";
			
			this.gridGroupingControl1.TableDescriptor.QueryValue += new FieldValueEventHandler(TableDescriptor_QueryValue);
			this.gridGroupingControl1.TableDescriptor.SaveValue += new FieldValueEventHandler(TableDescriptor_SaveValue);

			//save initial unbound values
			
			for(int i = 0; i < nRows; ++i)
			{
				object o = dt.Rows[i]["Col1"];
				this.unboundValues.Add(o, s[r.Next(3)]);
			}

			//set up combo for "Col2"
			style = this.gridGroupingControl1.TableDescriptor.Columns["Col2"].Appearance.AnyRecordFieldCell;
			style.CellType = "ComboBox";

			//create its datasource
			DataTable dt2 = new DataTable("Col2Combo");
			dt2.Columns.Add(new DataColumn("value"));
			DataView dv = new DataView(dt2, "", "value", DataViewRowState.CurrentRows);
			for(int i = 0; i < nRows; ++i)
			{
				object o = dt.Rows[i]["Col2"];
				if(dv.Find(o) == -1)
				{
					r1 = dt2.NewRow();
					r1[0] = o;
					dt2.Rows.Add(r1);
				}
			}
			
			style.DataSource = dv;
			style.DisplayMember = "value";
			style.ValueMember = "value";

			this.gridGroupingControl1.TableControlCurrentCellShowingDropDown += new GridTableControlCurrentCellShowingDropDownEventHandler(gridGroupingControl1_TableControlCurrentCellShowingDropDown);
		}

		private void TableDescriptor_QueryValue(object sender, FieldValueEventArgs e)
		{
			if (e.Record is AddNewRecord)
				return;

			if(e.Field.Name == "unbound")
			{
				object o = e.Record.GetValue("Col1");
				if(this.unboundValues.ContainsKey(o))
				{
					e.Value = this.unboundValues[o];
				}
			}
		}

		private void TableDescriptor_SaveValue(object sender, FieldValueEventArgs e)
		{
			if (e.Record is AddNewRecord)
				return;

			if(e.Field.Name == "unbound")
			{
				object o = e.Record.GetValue("Col1");
				if(this.unboundValues.ContainsKey(o))
				{
					this.unboundValues[o] = e.Value;
				}
				else
				{
					this.unboundValues.Add(o, e.Value);
				}
			}
		}

		private void gridGroupingControl1_TableControlCurrentCellShowingDropDown(object sender, GridTableControlCurrentCellShowingDropDownEventArgs e)
		{
			GridCurrentCell cc = e.TableControl.CurrentCell;
			GridTableCellStyleInfo style = e.TableControl.Model[cc.RowIndex, cc.ColIndex] as GridTableCellStyleInfo;
			if(style.TableCellIdentity.Column.Name == "Col2")
			{
				GridComboBoxCellRenderer cr = cc.Renderer as GridComboBoxCellRenderer;
				if(cr != null)
				{
					DataView dv = style.DataSource as DataView;
					int col = e.TableControl.Model.NameToColIndex("unbound");
					string s = string.Format("[value] LIKE '{0}*'", e.TableControl.Model[cc.RowIndex, col].Text);
					DataView dv1 = new DataView(dv.Table, s, "", DataViewRowState.CurrentRows);
					cr.ListBoxPart.DataSource = dv1;
				}
			}

		}
	}
}
